package cn.superdesk.uniorder.dao.entity.invoice.customer;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class InvoiceApplyXGoodsExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public InvoiceApplyXGoodsExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
    invoice_apply_x_goods
     *
     * @mbg.generated Tue Mar 22 19:08:57 CST 2022
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdIsNull() {
            addCriterion("invoice_apply_id is null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdIsNotNull() {
            addCriterion("invoice_apply_id is not null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdEqualTo(Long value) {
            addCriterion("invoice_apply_id =", value, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdNotEqualTo(Long value) {
            addCriterion("invoice_apply_id <>", value, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdGreaterThan(Long value) {
            addCriterion("invoice_apply_id >", value, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("invoice_apply_id >=", value, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdLessThan(Long value) {
            addCriterion("invoice_apply_id <", value, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdLessThanOrEqualTo(Long value) {
            addCriterion("invoice_apply_id <=", value, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdIn(List<Long> values) {
            addCriterion("invoice_apply_id in", values, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdNotIn(List<Long> values) {
            addCriterion("invoice_apply_id not in", values, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdBetween(Long value1, Long value2) {
            addCriterion("invoice_apply_id between", value1, value2, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplyIdNotBetween(Long value1, Long value2) {
            addCriterion("invoice_apply_id not between", value1, value2, "invoiceApplyId");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnIsNull() {
            addCriterion("invoice_apply_sn is null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnIsNotNull() {
            addCriterion("invoice_apply_sn is not null");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnEqualTo(String value) {
            addCriterion("invoice_apply_sn =", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotEqualTo(String value) {
            addCriterion("invoice_apply_sn <>", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnGreaterThan(String value) {
            addCriterion("invoice_apply_sn >", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnGreaterThanOrEqualTo(String value) {
            addCriterion("invoice_apply_sn >=", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnLessThan(String value) {
            addCriterion("invoice_apply_sn <", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnLessThanOrEqualTo(String value) {
            addCriterion("invoice_apply_sn <=", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnLike(String value) {
            addCriterion("invoice_apply_sn like", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotLike(String value) {
            addCriterion("invoice_apply_sn not like", value, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnIn(List<String> values) {
            addCriterion("invoice_apply_sn in", values, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotIn(List<String> values) {
            addCriterion("invoice_apply_sn not in", values, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnBetween(String value1, String value2) {
            addCriterion("invoice_apply_sn between", value1, value2, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andInvoiceApplySnNotBetween(String value1, String value2) {
            addCriterion("invoice_apply_sn not between", value1, value2, "invoiceApplySn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdIsNull() {
            addCriterion("accounting_order_id is null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdIsNotNull() {
            addCriterion("accounting_order_id is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdEqualTo(Long value) {
            addCriterion("accounting_order_id =", value, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdNotEqualTo(Long value) {
            addCriterion("accounting_order_id <>", value, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdGreaterThan(Long value) {
            addCriterion("accounting_order_id >", value, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("accounting_order_id >=", value, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdLessThan(Long value) {
            addCriterion("accounting_order_id <", value, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("accounting_order_id <=", value, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdIn(List<Long> values) {
            addCriterion("accounting_order_id in", values, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdNotIn(List<Long> values) {
            addCriterion("accounting_order_id not in", values, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdBetween(Long value1, Long value2) {
            addCriterion("accounting_order_id between", value1, value2, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("accounting_order_id not between", value1, value2, "accountingOrderId");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIsNull() {
            addCriterion("accounting_order_sn is null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIsNotNull() {
            addCriterion("accounting_order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnEqualTo(String value) {
            addCriterion("accounting_order_sn =", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotEqualTo(String value) {
            addCriterion("accounting_order_sn <>", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnGreaterThan(String value) {
            addCriterion("accounting_order_sn >", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("accounting_order_sn >=", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLessThan(String value) {
            addCriterion("accounting_order_sn <", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLessThanOrEqualTo(String value) {
            addCriterion("accounting_order_sn <=", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnLike(String value) {
            addCriterion("accounting_order_sn like", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotLike(String value) {
            addCriterion("accounting_order_sn not like", value, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnIn(List<String> values) {
            addCriterion("accounting_order_sn in", values, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotIn(List<String> values) {
            addCriterion("accounting_order_sn not in", values, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnBetween(String value1, String value2) {
            addCriterion("accounting_order_sn between", value1, value2, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderSnNotBetween(String value1, String value2) {
            addCriterion("accounting_order_sn not between", value1, value2, "accountingOrderSn");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeIsNull() {
            addCriterion("accounting_order_type is null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeIsNotNull() {
            addCriterion("accounting_order_type is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeEqualTo(Integer value) {
            addCriterion("accounting_order_type =", value, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeNotEqualTo(Integer value) {
            addCriterion("accounting_order_type <>", value, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeGreaterThan(Integer value) {
            addCriterion("accounting_order_type >", value, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("accounting_order_type >=", value, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeLessThan(Integer value) {
            addCriterion("accounting_order_type <", value, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeLessThanOrEqualTo(Integer value) {
            addCriterion("accounting_order_type <=", value, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeIn(List<Integer> values) {
            addCriterion("accounting_order_type in", values, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeNotIn(List<Integer> values) {
            addCriterion("accounting_order_type not in", values, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeBetween(Integer value1, Integer value2) {
            addCriterion("accounting_order_type between", value1, value2, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andAccountingOrderTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("accounting_order_type not between", value1, value2, "accountingOrderType");
            return (Criteria) this;
        }

        public Criteria andDimCreateByIsNull() {
            addCriterion("dim_create_by is null");
            return (Criteria) this;
        }

        public Criteria andDimCreateByIsNotNull() {
            addCriterion("dim_create_by is not null");
            return (Criteria) this;
        }

        public Criteria andDimCreateByEqualTo(Integer value) {
            addCriterion("dim_create_by =", value, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByNotEqualTo(Integer value) {
            addCriterion("dim_create_by <>", value, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByGreaterThan(Integer value) {
            addCriterion("dim_create_by >", value, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByGreaterThanOrEqualTo(Integer value) {
            addCriterion("dim_create_by >=", value, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByLessThan(Integer value) {
            addCriterion("dim_create_by <", value, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByLessThanOrEqualTo(Integer value) {
            addCriterion("dim_create_by <=", value, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByIn(List<Integer> values) {
            addCriterion("dim_create_by in", values, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByNotIn(List<Integer> values) {
            addCriterion("dim_create_by not in", values, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByBetween(Integer value1, Integer value2) {
            addCriterion("dim_create_by between", value1, value2, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andDimCreateByNotBetween(Integer value1, Integer value2) {
            addCriterion("dim_create_by not between", value1, value2, "dimCreateBy");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdIsNull() {
            addCriterion("unified_order_id is null");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdIsNotNull() {
            addCriterion("unified_order_id is not null");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdEqualTo(Long value) {
            addCriterion("unified_order_id =", value, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdNotEqualTo(Long value) {
            addCriterion("unified_order_id <>", value, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdGreaterThan(Long value) {
            addCriterion("unified_order_id >", value, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdGreaterThanOrEqualTo(Long value) {
            addCriterion("unified_order_id >=", value, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdLessThan(Long value) {
            addCriterion("unified_order_id <", value, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdLessThanOrEqualTo(Long value) {
            addCriterion("unified_order_id <=", value, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdIn(List<Long> values) {
            addCriterion("unified_order_id in", values, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdNotIn(List<Long> values) {
            addCriterion("unified_order_id not in", values, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdBetween(Long value1, Long value2) {
            addCriterion("unified_order_id between", value1, value2, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderIdNotBetween(Long value1, Long value2) {
            addCriterion("unified_order_id not between", value1, value2, "unifiedOrderId");
            return (Criteria) this;
        }

        public Criteria andOrderSnIsNull() {
            addCriterion("order_sn is null");
            return (Criteria) this;
        }

        public Criteria andOrderSnIsNotNull() {
            addCriterion("order_sn is not null");
            return (Criteria) this;
        }

        public Criteria andOrderSnEqualTo(String value) {
            addCriterion("order_sn =", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotEqualTo(String value) {
            addCriterion("order_sn <>", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnGreaterThan(String value) {
            addCriterion("order_sn >", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnGreaterThanOrEqualTo(String value) {
            addCriterion("order_sn >=", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLessThan(String value) {
            addCriterion("order_sn <", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLessThanOrEqualTo(String value) {
            addCriterion("order_sn <=", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnLike(String value) {
            addCriterion("order_sn like", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotLike(String value) {
            addCriterion("order_sn not like", value, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnIn(List<String> values) {
            addCriterion("order_sn in", values, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotIn(List<String> values) {
            addCriterion("order_sn not in", values, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnBetween(String value1, String value2) {
            addCriterion("order_sn between", value1, value2, "orderSn");
            return (Criteria) this;
        }

        public Criteria andOrderSnNotBetween(String value1, String value2) {
            addCriterion("order_sn not between", value1, value2, "orderSn");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdIsNull() {
            addCriterion("unified_order_goods_id is null");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdIsNotNull() {
            addCriterion("unified_order_goods_id is not null");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdEqualTo(Long value) {
            addCriterion("unified_order_goods_id =", value, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdNotEqualTo(Long value) {
            addCriterion("unified_order_goods_id <>", value, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdGreaterThan(Long value) {
            addCriterion("unified_order_goods_id >", value, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdGreaterThanOrEqualTo(Long value) {
            addCriterion("unified_order_goods_id >=", value, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdLessThan(Long value) {
            addCriterion("unified_order_goods_id <", value, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdLessThanOrEqualTo(Long value) {
            addCriterion("unified_order_goods_id <=", value, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdIn(List<Long> values) {
            addCriterion("unified_order_goods_id in", values, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdNotIn(List<Long> values) {
            addCriterion("unified_order_goods_id not in", values, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdBetween(Long value1, Long value2) {
            addCriterion("unified_order_goods_id between", value1, value2, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderGoodsIdNotBetween(Long value1, Long value2) {
            addCriterion("unified_order_goods_id not between", value1, value2, "unifiedOrderGoodsId");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromIsNull() {
            addCriterion("goods_id_source_from is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromIsNotNull() {
            addCriterion("goods_id_source_from is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromEqualTo(String value) {
            addCriterion("goods_id_source_from =", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromNotEqualTo(String value) {
            addCriterion("goods_id_source_from <>", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromGreaterThan(String value) {
            addCriterion("goods_id_source_from >", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromGreaterThanOrEqualTo(String value) {
            addCriterion("goods_id_source_from >=", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromLessThan(String value) {
            addCriterion("goods_id_source_from <", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromLessThanOrEqualTo(String value) {
            addCriterion("goods_id_source_from <=", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromLike(String value) {
            addCriterion("goods_id_source_from like", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromNotLike(String value) {
            addCriterion("goods_id_source_from not like", value, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromIn(List<String> values) {
            addCriterion("goods_id_source_from in", values, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromNotIn(List<String> values) {
            addCriterion("goods_id_source_from not in", values, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromBetween(String value1, String value2) {
            addCriterion("goods_id_source_from between", value1, value2, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdSourceFromNotBetween(String value1, String value2) {
            addCriterion("goods_id_source_from not between", value1, value2, "goodsIdSourceFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromIsNull() {
            addCriterion("goods_id_root_from is null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromIsNotNull() {
            addCriterion("goods_id_root_from is not null");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromEqualTo(String value) {
            addCriterion("goods_id_root_from =", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromNotEqualTo(String value) {
            addCriterion("goods_id_root_from <>", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromGreaterThan(String value) {
            addCriterion("goods_id_root_from >", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromGreaterThanOrEqualTo(String value) {
            addCriterion("goods_id_root_from >=", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromLessThan(String value) {
            addCriterion("goods_id_root_from <", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromLessThanOrEqualTo(String value) {
            addCriterion("goods_id_root_from <=", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromLike(String value) {
            addCriterion("goods_id_root_from like", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromNotLike(String value) {
            addCriterion("goods_id_root_from not like", value, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromIn(List<String> values) {
            addCriterion("goods_id_root_from in", values, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromNotIn(List<String> values) {
            addCriterion("goods_id_root_from not in", values, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromBetween(String value1, String value2) {
            addCriterion("goods_id_root_from between", value1, value2, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andGoodsIdRootFromNotBetween(String value1, String value2) {
            addCriterion("goods_id_root_from not between", value1, value2, "goodsIdRootFrom");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdIsNull() {
            addCriterion("unified_order_credit_id is null");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdIsNotNull() {
            addCriterion("unified_order_credit_id is not null");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdEqualTo(Long value) {
            addCriterion("unified_order_credit_id =", value, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdNotEqualTo(Long value) {
            addCriterion("unified_order_credit_id <>", value, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdGreaterThan(Long value) {
            addCriterion("unified_order_credit_id >", value, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdGreaterThanOrEqualTo(Long value) {
            addCriterion("unified_order_credit_id >=", value, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdLessThan(Long value) {
            addCriterion("unified_order_credit_id <", value, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdLessThanOrEqualTo(Long value) {
            addCriterion("unified_order_credit_id <=", value, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdIn(List<Long> values) {
            addCriterion("unified_order_credit_id in", values, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdNotIn(List<Long> values) {
            addCriterion("unified_order_credit_id not in", values, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdBetween(Long value1, Long value2) {
            addCriterion("unified_order_credit_id between", value1, value2, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andUnifiedOrderCreditIdNotBetween(Long value1, Long value2) {
            addCriterion("unified_order_credit_id not between", value1, value2, "unifiedOrderCreditId");
            return (Criteria) this;
        }

        public Criteria andAccountingStateIsNull() {
            addCriterion("accounting_state is null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateIsNotNull() {
            addCriterion("accounting_state is not null");
            return (Criteria) this;
        }

        public Criteria andAccountingStateEqualTo(Integer value) {
            addCriterion("accounting_state =", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateNotEqualTo(Integer value) {
            addCriterion("accounting_state <>", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateGreaterThan(Integer value) {
            addCriterion("accounting_state >", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateGreaterThanOrEqualTo(Integer value) {
            addCriterion("accounting_state >=", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateLessThan(Integer value) {
            addCriterion("accounting_state <", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateLessThanOrEqualTo(Integer value) {
            addCriterion("accounting_state <=", value, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateIn(List<Integer> values) {
            addCriterion("accounting_state in", values, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateNotIn(List<Integer> values) {
            addCriterion("accounting_state not in", values, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateBetween(Integer value1, Integer value2) {
            addCriterion("accounting_state between", value1, value2, "accountingState");
            return (Criteria) this;
        }

        public Criteria andAccountingStateNotBetween(Integer value1, Integer value2) {
            addCriterion("accounting_state not between", value1, value2, "accountingState");
            return (Criteria) this;
        }

        public Criteria andBackStatusIsNull() {
            addCriterion("back_status is null");
            return (Criteria) this;
        }

        public Criteria andBackStatusIsNotNull() {
            addCriterion("back_status is not null");
            return (Criteria) this;
        }

        public Criteria andBackStatusEqualTo(Integer value) {
            addCriterion("back_status =", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusNotEqualTo(Integer value) {
            addCriterion("back_status <>", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusGreaterThan(Integer value) {
            addCriterion("back_status >", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("back_status >=", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusLessThan(Integer value) {
            addCriterion("back_status <", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusLessThanOrEqualTo(Integer value) {
            addCriterion("back_status <=", value, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusIn(List<Integer> values) {
            addCriterion("back_status in", values, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusNotIn(List<Integer> values) {
            addCriterion("back_status not in", values, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusBetween(Integer value1, Integer value2) {
            addCriterion("back_status between", value1, value2, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBackStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("back_status not between", value1, value2, "backStatus");
            return (Criteria) this;
        }

        public Criteria andBankIdIsNull() {
            addCriterion("bank_id is null");
            return (Criteria) this;
        }

        public Criteria andBankIdIsNotNull() {
            addCriterion("bank_id is not null");
            return (Criteria) this;
        }

        public Criteria andBankIdEqualTo(Long value) {
            addCriterion("bank_id =", value, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdNotEqualTo(Long value) {
            addCriterion("bank_id <>", value, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdGreaterThan(Long value) {
            addCriterion("bank_id >", value, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdGreaterThanOrEqualTo(Long value) {
            addCriterion("bank_id >=", value, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdLessThan(Long value) {
            addCriterion("bank_id <", value, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdLessThanOrEqualTo(Long value) {
            addCriterion("bank_id <=", value, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdIn(List<Long> values) {
            addCriterion("bank_id in", values, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdNotIn(List<Long> values) {
            addCriterion("bank_id not in", values, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdBetween(Long value1, Long value2) {
            addCriterion("bank_id between", value1, value2, "bankId");
            return (Criteria) this;
        }

        public Criteria andBankIdNotBetween(Long value1, Long value2) {
            addCriterion("bank_id not between", value1, value2, "bankId");
            return (Criteria) this;
        }

        public Criteria andBackTimeIsNull() {
            addCriterion("back_time is null");
            return (Criteria) this;
        }

        public Criteria andBackTimeIsNotNull() {
            addCriterion("back_time is not null");
            return (Criteria) this;
        }

        public Criteria andBackTimeEqualTo(Date value) {
            addCriterion("back_time =", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeNotEqualTo(Date value) {
            addCriterion("back_time <>", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeGreaterThan(Date value) {
            addCriterion("back_time >", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("back_time >=", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeLessThan(Date value) {
            addCriterion("back_time <", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeLessThanOrEqualTo(Date value) {
            addCriterion("back_time <=", value, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeIn(List<Date> values) {
            addCriterion("back_time in", values, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeNotIn(List<Date> values) {
            addCriterion("back_time not in", values, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeBetween(Date value1, Date value2) {
            addCriterion("back_time between", value1, value2, "backTime");
            return (Criteria) this;
        }

        public Criteria andBackTimeNotBetween(Date value1, Date value2) {
            addCriterion("back_time not between", value1, value2, "backTime");
            return (Criteria) this;
        }
    }

    /**
    invoice_apply_x_goods
     *
     * @mbg.generated do_not_delete_during_merge Tue Mar 22 19:08:57 CST 2022
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
    invoice_apply_x_goods
     *
     * @mbg.generated Tue Mar 22 19:08:57 CST 2022
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}